<template>
  <el-dialog
      v-model="props.visible"
      :title="props.levelId?'编辑':'新增'"
      width="500"
      :close-on-click-modal="false"
      :before-close="dialogClose"
  >
    <el-form
        class="ls-form"
        ref="formRef"
        :model="formData"
        label-width="80px"
    >
      <el-form-item
          label="职级名称"
          prop="name"
          :rules="{ required: true, message: '请输入职级名称', trigger: 'blur' }"
      >
        <el-input
            class="ls-input"
            v-model="formData.name"
            placeholder="请输入职级名称"
            clearable
        />
      </el-form-item>
      <el-form-item label="职级状态" prop="status">
          <el-radio-group v-model="formData.status" name="status">
            <el-radio :value="1">正常</el-radio>
            <el-radio :value="2">停用</el-radio>
          </el-radio-group>
        </el-form-item>
      <el-form-item label="排序" prop="sort">
        <el-input-number v-model="formData.sort"/>
      </el-form-item>
    </el-form>
    <template #footer>
      <span class="dialog-footer">
        <el-button @click="dialogClose">取消</el-button>
        <el-button :loading="subLoading" type="primary" @click="submit">
          确定
        </el-button>
      </span>
    </template>
  </el-dialog>
</template>
<script lang="ts" setup>
import type {FormInstance} from "element-plus";
import {getLevelDetail,levelAdd,levelUpdate} from "@/api/system/level";
import {onMounted, reactive, shallowRef} from "vue";
import {message} from "@/utils/auth";
import {useLockFn} from "@/utils/useLockFn";

const emit = defineEmits(["success", "update:visible"]);
const formRef = shallowRef<FormInstance>();
const formData = reactive({
  id: "",
  name: "",
  status: 1,
  sort: 0
});

const props = defineProps({
  visible: {
    type: Boolean,
    required: true,
    default: false
  },
  levelId: {
    type: Number,
    required: true,
    default: 0
  }
});

const handleSubmit = async () => {
    await formRef.value?.validate();
    props.levelId ? await levelUpdate(formData) : await levelAdd(formData);
    message("操作成功");
    emit("update:visible", false);
    emit("success");
};

const dialogClose = () => {
  emit("update:visible", false);
};

const { isLock:subLoading,lockFn: submit } = useLockFn(handleSubmit);


const setFormData = async () => {
  const data = await getLevelDetail(props.levelId);
  for (const key in formData) {
    if (data[key] != null && data[key] != undefined) {
      //@ts-ignore
      formData[key] = data[key];
    }
  }
};

onMounted(() => {
  if (props.levelId) {
    setFormData();
  }
});

</script>
